#include <Shared/Shrink.h>
#include "BingWindow.h"
#include <Shared/StringUtil.h>

BingWindow::BingWindow() : HttpWindow(L"Bing", L"http://www.microsofttranslator.com") {
  host = L"api.microsofttranslator.com";
  path = L"/V2/Http.svc/Translate?appId=A6092CB6102F7AD23920D520B0435F7D9BF36506&from=%hs&to=%hs&text=";
  eatBRs = 0;
}

char* BingWindow::GetLangIdString(Language lang, int src) {
  if (src && lang == LANGUAGE_Chinese_Traditional) {
    lang = LANGUAGE_Chinese_Simplified;
  }
  switch(lang) {
    case LANGUAGE_AUTO:
      return "auto";
    case LANGUAGE_ENGLISH:
      return "en";
    case LANGUAGE_JAPANESE:
      return "ja";

    case LANGUAGE_Arabic:
      return "ar";
    case LANGUAGE_Bulgarian:
      return "bg";
    case LANGUAGE_Chinese_Simplified:
      return "zh-CHS";
    case LANGUAGE_Chinese_Traditional:
      return "zh-CHT";
    case LANGUAGE_Czech:
      return "cs";
    case LANGUAGE_Danish:
      return "da";
    case LANGUAGE_Dutch:
      return "nl";
    case LANGUAGE_Estonian:
      return "et";
    case LANGUAGE_Finnish:
      return "fi";
    case LANGUAGE_French:
      return "fr";
    case LANGUAGE_German:
      return "de";
    case LANGUAGE_Greek:
      return "el";
    case LANGUAGE_Haitian_Creole:
      return "ht";
    case LANGUAGE_Hebrew:
      return "he";
    case LANGUAGE_Hungarian:
      return "hu";
    case LANGUAGE_Indonesian:
      return "id";
    case LANGUAGE_Italian:
      return "it";
    case LANGUAGE_Korean:
      return "ko";
    case LANGUAGE_Latvian:
      return "lv";
    case LANGUAGE_Lithuanian:
      return "lt";
    case LANGUAGE_Norwegian:
      return "no";
    case LANGUAGE_Polish:
      return "pl";
    case LANGUAGE_Portuguese:
      return "pt";
    case LANGUAGE_Romanian:
      return "ro";
    case LANGUAGE_Russian:
      return "ru";
    case LANGUAGE_Slovak:
      return "sk:";
    case LANGUAGE_Slovenian:
      return "sl";
    case LANGUAGE_Spanish:
      return "es";
    case LANGUAGE_Swedish:
      return "sv";
    case LANGUAGE_Thai:
      return "th";
    case LANGUAGE_Turkish:
      return "tr";
    case LANGUAGE_Ukrainian:
      return "uk";
    case LANGUAGE_Vietnamese:
      return "vi";
    default:
      return 0;
  }
}
